function [user_satisfaction, throughput] = ffr_calculation(userBaseX,userBaseY,userX,userY,userType,red_cells,blue_cells,green_cells)

	global r;
	global rc;
	global nr;
	global nc;
	global isd;
	global penLoss;
	global mSignalPower;
	global mInnerSignalPower;
	global WGNVariance;
	global numberofusers;
	global f;
	global ht;
	global hm;
	global minfreq;
	global freqstep;
	global maxfreq;
	global Df;


i=1;
for rc=0:(0.3*sqrt(3)/(2*r)):(r*sqrt(3)/2)
	j=1;
	numberOfOuterArea=0;
	numberOfInnerArea=0;
	for z=1:numberofusers
		if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
			dist=sqrt((userBaseX(z)-userX(z))^2+(userBaseY(z)-userY(z))^2);
			if (dist>rc)
				numberOfOuterArea=numberOfOuterArea+1;
			else
				numberOfInnerArea=numberOfInnerArea+1;
			end
		end
	end
	for bd=minfreq:freqstep:maxfreq
		throughput(i,j)=0;
		maxthroughput=0;
		totalusers=0;
		for z=1:numberofusers
			if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
				totalusers=totalusers+1;
				[user_area(z) user_sinr(z)]=sinr(userX(z),userY(z),userBaseX(z),userBaseY(z),userType(z),red_cells,blue_cells,green_cells);
				if (user_area(z)==0)
					capacity = ((Df-bd)/(3*numberOfOuterArea)) * log2(1 + user_sinr(z));
					throughput(i,j) = throughput(i,j)+0.6*capacity;
					if maxthroughput<0.6*capacity
						maxthroughput=0.6*capacity;
					end
				else
					capacity = (bd/numberOfInnerArea) * log2(1 + user_sinr(z));
					throughput(i,j) = throughput(i,j)+0.6*capacity;
					if maxthroughput<(0.6*capacity)
						maxthroughput=0.6*capacity;
					end
				end
			end
		end
		user_satisfaction(i,j)=throughput(i,j)/(maxthroughput*totalusers);
		j=j+1;
	end
	% fprintf('i=%d,j=%d,z=%d\n',i,j,z);
	i=i+1;
end